#ifndef _EX_HOSTAPPSERVICES_H_
#define _EX_HOSTAPPSERVICES_H_

#include "DbHostAppServices.h"
#include "HatchPatternManager.h"
#include "StaticRxObject.h"
#include "DbDatabaseReactor.h"
#include <map>

class ExHostAppServices : public OdDbHostAppServices, public OdDbHostAppProgressMeter
{
  class DwgCollection : public OdStaticRxObject<OdDbDatabaseReactor>
  {
    std::map<OdString, OdDbDatabase*> m_loadedDwgs;
    void goodbye(const OdDbDatabase* pDb);
  public:
    OdDbDatabase* lookUp(const OdString& keyFileName);
    void add(OdDbDatabase* pDb);
  }         m_dwgCollection;
  OdString  m_Prefix;
  long      m_MeterLimit;
  long      m_MeterCurrent;
  long      m_MeterOld;
  bool      m_disableOutput;

  OdHatchPatternManagerPtr m_patternManager;
public:
  ExHostAppServices();

  OdDbHostAppProgressMeter* newProgressMeter();

  void releaseProgressMeter(OdDbHostAppProgressMeter* pMeter);

  void warning(const OdString& ) { }

  DD_USING(OdDbHostAppServices::warning); 

	// OdDbHostAppProgressMeter functions
  void start(const char* displayString = NULL);

  void stop();

  void meterProgress();

  void setLimit(int max);

  bool ttfFileNameByDescriptor(const OdTtfDescriptor& descr, OdString& fileName);

  void disableOutput(bool bDisable) { m_disableOutput = bDisable; }

  void setPrefix(const OdString& prefix) { m_Prefix = prefix; }

  OdHatchPatternManager* patternManager();

  OdDbDatabasePtr readFile(const OdChar* fileName,
    bool bAllowCPConversion = false,
    bool bPartial = false,
    Oda::FileShareMode shmode = Oda::kShareDenyNo,
    const OdPassword& password = OdPassword());

  DD_USING(OdDbHostAppServices::readFile);
};

#endif

