	/***************************************************************************
                          dc.h  -  description
                             -------------------
    begin                : Wed Jan 14 11:54:40 EST 2004
    copyright            : (C) 2004 by Andrew Bibb
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DC_H
#define DC_H

// include files for QT
#include <qdialog.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qtoolbutton.h>
#include <qtextedit.h>
#include <qfiledialog.h>

// include files for OpenDWG

#include "OdaCommon.h"
#include "DbDatabase.h"
#include "RxObjectImpl.h"
#include "DwgDirect/svcs/ExSystemServices.h"
#include "DwgDirect/svcs/ExHostAppServices.h"
#include "OdFileBuf.h"

class DC_System_HostServices : public ExSystemServices, public ExHostAppServices
{
	protected:
		ODRX_USING_HEAP_OPERATORS(ExSystemServices);
	
};


class dc_Dialog : public QDialog
{
        Q_OBJECT

	public:
		dc_Dialog(QWidget* parent = 0, const char* name = 0, bool modal = false);
		~dc_Dialog();

	public slots:
		void callOpenDialog();
		void callSaveDialog();
		void toggleDXFOptions(int);
		void toggleConsoleWindow();
		void convertPressed();
		

	private:
		//	data members
		QFileDialog* p2fod;
		QFileDialog* p2fsd;
		
		QLineEdit* in_line;
		QPushButton* in_browse;

		QLineEdit* out_line;
		QPushButton* out_browse;

		QComboBox* version_sel;
		QRadioButton* dwg_radbut;
		QRadioButton* dxf_radbut;
		QLabel* spin_label;
		QSpinBox* dxf_prec;

		QCheckBox* seperate1_ckbx;
		QCheckBox* seperate2_ckbx;

		QLabel* credits;
		QLabel* odlic;

		QToolButton* whatsthis_but;
		QPushButton* conv_but;
		QPushButton* cancel_but;

		QTextEdit* conwin;

		OdRxObjectImpl<DC_System_HostServices> dc_svcs;
		OdDbDatabasePtr pDb;
		
		//	functions
		bool convertFile(OdDb::SaveType, OdDb::DwgVersion);
		QString validateSelection(const QString&);	
		
};
#endif 

